from Graphenprojekt.leinwand import Leinwand
import tkinter as tk
import tkinter.font # wie?

class Knoten:
    """
    Stellt einen Knoten dar.
    """

    fg,bg = 'black','white'
    def dunkelModus():
        Knoten.fg,Knoten.bg = 'white','black'
    def hellModus():
        Knoten.fg,Knoten.bg = 'black','white'

##    def aendereRandFarbe(name, neueFarbe):
##        Controller().gibKnotenZuNamen(name).aendereRandFarbe(neueFarbe)

    def __init__(self,name,xPosition=20,yPosition=20):
        """
        Erzeugt einen Knoten an der gegebenen Position.
        xPosition: die x-Koordinate der oberen linken Ecke des Knoten
        yPosition: die y-Koordinate der oberen linken Ecke des Knoten
        farbe: die Farbe, in der der Knoten angezeigt werden soll.
               Dies sollte einer der Farbnamen der Klasse Farben sein.  
        """
        self.name = name
        self.xPosition = xPosition
        self.yPosition = yPosition
        self.breite = 20
        self.tiefe = 20
        self.farbe = Knoten.fg
        self.fuellFarbe = Knoten.bg
        self.formen = [] # enthaelt die IDs
        self.leinwand = Leinwand()
        self.ID = None

    def gibMitte(self):
        return self.xPosition+self.breite//2,self.yPosition+self.tiefe//2
    def gibID(self): return self.ID
    def gibNamen(self): return self.name

    def zeige(self):
        """ Zeigt diesen Knoten an. """
        if not self.formen:
            umriss = self.leinwand.ellipse(self.xPosition,self.yPosition,
                                           self.xPosition+self.breite,self.yPosition+self.tiefe,
                                           width=2,
                                           outline=self.farbe,
                                           fill=self.fuellFarbe,
                                           tag=self.name)
            self.formen.append(umriss)
            self.ID = umriss
            ## Beschriftung
            if len(self.name)==1:
                xText,yText=self.xPosition+self.breite//2,self.yPosition+self.tiefe//2
                ausrichtung = tk.CENTER
            else:
                xText,yText = self.xPosition+self.breite,self.yPosition+self.tiefe
                ausrichtung = tk.NW 
            beschriftung = self.leinwand.text(xText,yText,self.name,
                                              font=('Helvetica',11,'bold'),
                                              anchor=ausrichtung,tag=self.name)

    def verberge(self):
        """ Entfernt diesen Knoten aus der Ansicht. """
        for form in self.formen:
            self.leinwand.loesche(form)
        self.formen = []

    def aendereRandFarbe(self,neueFarbe):
        """ aendert die Randfarbe des Knoten"""
        self.verberge()
        self.farbe = neueFarbe
        self.zeige()
        
    def aendereFuellFarbe(self,neueFarbe):
        """ aendert die Füllfarbe des Knoten
        die Füllfarbe darf nicht transparent sein"""
        if neueFarbe == "transparent": return
        self.verberge()
        self.fuellFarbe = neueFarbe
        self.zeige()
        
