# gallenbacher_dijkstra_objektorientiert.py
# Programm entsprechend der Algorithmusformulierung von Gallenbacher

from Graphenprojekt import *
cont=Controller()

class Weg():
    def __init__(self,knotenListe,laenge):
        self.knotenListe=knotenListe
        self.laenge=laenge

    def gibKnotenListe(self): return self.knotenListe
    def gibLaenge(self): return self.laenge

    def gibWegDaten(self):
        return self.knotenListe,self.laenge
    
    def zeigeWeg(self):
        text=str(self.knotenListe)
        text+=', Ziel: '+ziel+', laenge='+str(self.laenge)
        return text

    def letzter(self):
        return self.knotenListe[len(self.knotenListe)-1]
    
    def vorLetzter(self):
        return self.knotenListe[len(self.knotenListe)-2]
    
## muss an das Graphenprojekt angepasst werden:
    def nachfolgeKanten(self):
        aktuell=self.letzter()
        nachfolger=graph[aktuell]
        kanten=[]
        for nachF in nachfolger:
            neu=cont.gibKante(aktuell,nachF[0])
            if not neu:
                continue
            elif nachF[0] in self.knotenListe: # Rückwege weglassen
                continue
            else:
                kanten.append(neu)
                cont.aendereRandFarbe(Kante,
                                      aktuell,
                                      'red',
                                      nachF[0])
        for kante in kanten:
            print('nachfolgeKanten',kante.gibKnotenNamen(),kante.gibBewertung())
        return kanten

    def fortsetzenMit(self, kante):
        aktuell=self.letzter()
        if aktuell==kante.gibVon():
            self.knotenListe.append(kante.gibNach())
            self.laenge+=kante.gibBewertung()
        if aktuell==kante.gibNach():
            self.knotenListe.append(kante.gibVon())
            self.laenge+=kante.gibBewertung()
        else:       # sollte nicht passieren
            return  # setzt nicht fort

    def neueWege(self):
        '''erzeugt alle fortsetzenden Wege'''
        neue=[]
        knotenListe,laenge=self.gibWegDaten()
        for kante in self.nachfolgeKanten():
            liste=[]+knotenListe
            weg=Weg(liste,laenge)
            weg.fortsetzenMit(kante) # der neu erzeugte, nicht self
            if weg.letzter() in rote: # laengere weglassen
                if weg.gibLaenge()>rote[weg.letzter()].gibLaenge():
                    continue
            neue.append(weg)
        return neue

class prioSchlange():
    def __init__(self, startWeg):
        self.wege=[startWeg]

    def gibWege(self):
        return self.wege

    def hatWege(self):
        return len(self.wege)>0

    def vor(self, erster, zweiter):
        return erster.gibLaenge()<zweiter.gibLaenge()
        
    def holeErsten(self):
        if not self.hatWege(): return None
        return self.wege[0]

    def entferneErsten(self):
        if not self.hatWege(): return None
        self.wege=self.wege[1:]
        
    def fuegeEinenEin(self, neu):
        '''fuegt einen neuen Weg in die PrioWS ein'''
        wege=[]+self.wege   ## echte Kopie der Wege
        pos=len(wege) # ggf hinten ran
        for weg in wege:
            if self.vor(neu,weg):
                pos=wege.index(weg)
                break
        self.wege.insert(pos,neu)

    def fuegeEin(self, wege):
        for weg in wege:
            self.fuegeEinenEin(weg)

    def entferneLaengere(self, aktuell):
        '''entfernt alle Wege zum aktuellen Knoten
        bis auf den kürzesten'''
        kuerzster=None        
        for weg in self.wege:    ## kuerzesten suchen
            if aktuell==weg.letzter():
                if not kuerzester:
                    kuerzester=weg
                elif self.vor(weg,kuerzester):
                    kuerzester=weg
        temp=[]+self.wege   ## echte Kopie der Wege
        for i in range(len(temp)):  ## andere entfernen
            if aktuell==temp[i].letzter():
                if temp[i]!=kuerzester:
                    self.wege.remove(temp[i])

    def zeigeSchlange(self):
        for weg in self.wege:
            print(weg.gibWegDaten())

    def amZiel(self):
        if not self.hatWege(): return False
        aktuell=self.holeErsten()
        if aktuell.letzter()==ziel:
            return True
        return False
    
def faerben(rote):
    '''erst alles schwarz, dann Kanten zu Wegen rot'''
    for kante in cont.kantenListe:
        cont.aendereRandFarbe(Kante,
                              kante.gibVon(),
                              'black',
                              kante.gibNach())
    for rot in rote:
        weg=rote[rot]
        alleKnoten=weg.gibKnotenListe()
        for i in range(len(alleKnoten)-1):
            cont.aendereRandFarbe(Kante,
                                  alleKnoten[i],
                                  'red',
                                  alleKnoten[i+1])

def dijkstra(rote, prioWS):
    if (prioWS.hatWege()) and not (prioWS.amZiel()):
        aktuell=prioWS.holeErsten()
        if aktuell.letzter() in rote:
            if rote[aktuell.letzter()].gibLaenge()<aktuell.gibLaenge():
                print(aktuell.gibWegDaten(), 'bereits kuerzer erreicht')
                print('Weiter mit\nrote,prioWS=dijkstra(rote,prioWS)')
                prioWS.entferneErsten() # schon kuerzer erreicht
                return rote,prioWS
        prioWS.entferneErsten()
        rote.update({aktuell.letzter():aktuell})
        print('dijkstra',rote[aktuell.letzter()].knotenListe)
        print('aktueller Weg', aktuell.gibWegDaten())
        cont.aendereFuellFarbe(Knoten,aktuell.letzter(),'red')
        neue=aktuell.neueWege()
        print('fortsetzende Wege:')
        for weg in neue:
            print(weg.gibWegDaten())
        prioWS.fuegeEin(neue)
        print('aktuelle PrioWS:')
        prioWS.zeigeSchlange()
        faerben(rote)
        print('Weiter mit\nrote,prioWS=dijkstra(rote,prioWS)')
        return rote,prioWS
    if prioWS.amZiel():
        wegZumZiel=prioWS.holeErsten()
        cont.aendereFuellFarbe(Knoten,wegZumZiel.letzter(),'red')
        rote.update({wegZumZiel.letzter():wegZumZiel})
        faerben(rote)
        print('\nSuche beendet! Kürzester Weg:')
        print( wegZumZiel.gibWegDaten() ,'\n')
        return rote,prioWS.holeErsten().gibWegDaten()
    else:
        return False

### Vorbereitung:
## vorher die Graphendatei laden !!!
#print(graph)
start='I'
ziel='O'
weg=Weg([start],0)
rote={start:weg}
cont.aendereFuellFarbe(Knoten,start,'red')
prioWS=prioSchlange(weg)
graph=cont.gibKantenDict()
alleKanten=[]
for kante in cont.kantenListe:
    alleKanten.append((kante.gibVon(),kante.gibNach(),kante.gibBewertung()))
    alleKanten.append((kante.gibNach(),kante.gibVon(),kante.gibBewertung()))
##print(alleKanten)
##rote,prioWS=dijkstra(rote,prioWS)

## Für Dijkstra:
print('wiederholt eingeben:')
print('rote,prioWS=dijkstra(rote,prioWS)')
